/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.pvp.PvPHelper
 *  fire.pb.circletask.SPVP3MapConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.npc.SGeneralSummonCommand
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xtable.Properties
 */
package fire.pb.battle.pvp3;

import fire.pb.battle.pvp.PvPHelper;
import fire.pb.battle.pvp3.PvP3RoleProxy;
import fire.pb.circletask.SPVP3MapConfig;
import fire.pb.main.ConfigManager;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.npc.SGeneralSummonCommand;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import gnet.link.Onlines;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xtable.Properties;

public abstract class PvP3Helper
extends PvPHelper {
    public static final int ENTER_MIN_LEVEL = 45;
    public static final int TEAM_MAX_MEMBER_NUM = 3;
    public static final int RACE_MAX_BATTLE_NUM = 99;
    public static final int SCORE_MAX_BATTLE_NUM = 15;
    public static final int CONTINUE_WIN_MIN_NUM = 5;
    public static final long BATTLE_BETWEEN_MILLISECONDS = 5000L;
    public static final int FIRST_WIN_AWARD_ID = 6170;
    public static final int TEN_FIGHT_AWARD_ID = 6171;
    public static final int CONTINUE_WIN_AWARD_ID = 6172;

    public static int checkRoleEnterCondition(long roleId, int grade) {
        Team team = TeamManager.selectTeamByRoleId((long)roleId);
        if (team != null) {
            if (!team.isTeamLeader(roleId) || team.isAbsentMember(roleId)) {
                return -1;
            }
            List ids = team.getAllMemberIds();
            int teamSize = ids.size();
            if (teamSize > 3) {
                return -2;
            }
            Iterator iterator = ids.iterator();
            while (iterator.hasNext()) {
                long id = (Long)iterator.next();
                if (PvP3Helper.getRaceGradeByRoleId(id) == grade) continue;
                PvP3RoleProxy pvpRoleProxy = PvP3RoleProxy.getPvP3RoleProxy(id, true);
                if (pvpRoleProxy == null) {
                    return -3;
                }
                if (pvpRoleProxy.getGradeInActivity() == grade) continue;
                return -4;
            }
        }
        return 0;
    }

    public static boolean summonByRole(long roleId, int roleMapId) {
        if (PvP3Helper.isPvPMap(roleMapId)) {
            return false;
        }
        int grade = PvP3Helper.getRaceGradeByRoleId(roleId);
        if (grade <= 0) {
            return false;
        }
        SGeneralSummonCommand snd = new SGeneralSummonCommand();
        snd.roleid = 0L;
        snd.mapid = 0;
        snd.minimal = 0;
        snd.summontype = 15;
        if (Transaction.current() != null) {
            Procedure.psendWhileCommit((long)roleId, (Protocol)snd);
        } else {
            Onlines.getInstance().send(Long.valueOf(roleId), (Protocol)snd);
        }
        return true;
    }

    public static Collection<Integer> getAllRaceIds() {
        TreeMap cfgs = ConfigManager.getInstance().getConf(SPVP3MapConfig.class);
        return cfgs.keySet();
    }

    public static int getRaceGradeByRoleId(long roleId) {
        int level = Properties.selectLevel((Long)roleId);
        if (level < 45) {
            return -1;
        }
        return PvP3Helper.getRaceGradeByRoleLevel(level);
    }

    public static int getRaceGradeByRoleLevel(int level) {
        TreeMap confs = ConfigManager.getInstance().getConf(SPVP3MapConfig.class);
        for (Map.Entry entry : confs.entrySet()) {
            if (((SPVP3MapConfig)entry.getValue()).getLevel1() > level || level > ((SPVP3MapConfig)entry.getValue()).getLevel2()) continue;
            return (Integer)entry.getKey();
        }
        return 1;
    }

    public static int getMapIdByRaceGrade(int grade) {
        SPVP3MapConfig conf = (SPVP3MapConfig)ConfigManager.getInstance().getConf(SPVP3MapConfig.class).get(grade);
        if (conf == null) {
            return -1;
        }
        return conf.map;
    }

    public static int getRaceGradeByMapId(int mapId) {
        TreeMap confs = ConfigManager.getInstance().getConf(SPVP3MapConfig.class);
        for (Map.Entry entry : confs.entrySet()) {
            if (((SPVP3MapConfig)entry.getValue()).getMap() != mapId) continue;
            return (Integer)entry.getKey();
        }
        return -1;
    }

    public static boolean isPvPMap(int mapId) {
        return PvP3Helper.getRaceGradeByMapId(mapId) != -1;
    }

    public static boolean isSameGrade(long roleId1, long roleId2) {
        int grade2;
        int grade1 = PvP3Helper.getRaceGradeByRoleId(roleId1);
        return grade1 == (grade2 = PvP3Helper.getRaceGradeByRoleId(roleId2));
    }

    public static boolean isCanJoinPvPMapTeam(long leaderRoleId, long applyRoleId) {
        Role leaderMapRole = RoleManager.getInstance().getRoleByID(leaderRoleId);
        if (leaderMapRole == null) {
            return false;
        }
        return !PvP3Helper.isPvPMap(leaderMapRole.getMapId()) || PvP3Helper.isSameGrade(leaderRoleId, applyRoleId);
    }
}

